Skip to example

Split text

An example of creating a text reveal animation with split text in Motion for React

Source code

Tutorial

Tutorial time
5 min
Difficulty

Introduction

In this tutorial, we'll explore how to create a staggered text animation using the splitText utility from Motion+. This technique breaks text into individual words or characters that can be animated independently, creating elegant text reveal effects.

We'll learn how to use:

  • splitText to separate text into animatable elements
  • animate to control the animation of those elements
  • stagger to create sequential timing effects

Get started

Let's start by setting up our basic component structure:

import { useEffect, useRef } from "react"

export default function SplitText() {
    const containerRef = useRef(null)

    return (
        <div className="container" ref={containerRef}>
            <h1 className="h1">
                Level up your animations with the all-in membership
            </h1>
            <Stylesheet />
        </div>
    )
}

/**
 * Copy styles from example source code
 */

Note that we're setting visibility: hidden on the container. This prevents the text from showing until fonts are downloaded and we're ready to animate it.

Skip to example

Split text

An example of creating a text reveal animation with split text in Motion for Vue

Vue

Source code

<script setup lang="ts">
import { animate, stagger } from "motion"
import { splitText } from "motion-plus"
import { ref, onMounted } from "vue"

const containerRef = ref<HTMLDivElement | null>(null)

onMounted(() => {
    document.fonts.ready.then(() => {
        if (!containerRef.value) return

        // Hide the container until the fonts are loaded
        containerRef.value.style.visibility = "visible"

        const { words } = splitText(
            containerRef.value.querySelector("h1")!
        )

        // Animate the words in the h1
        animate(
            words,
            { opacity: [0, 1], y: [10, 0] },
            {
                type: "spring",
                duration: 2,
                bounce: 0,
                delay: stagger(0.05),
            }
        )
    })
})
</script>

<template>
    <div class="container" ref="containerRef">
        <h1 class="h1">
            Level up your animations with the all-in membership
        </h1>
    </div>
</template>

<style>
.container {
    display: flex;
    justify-content: center;
    align-items: center;
    width: 100%;
    max-width: 420px;
    text-align: left;
    visibility: hidden;
}

.split-word {
    will-change: transform, opacity;
}
</style>